FactoryCreateRule (Apache Tomcat 9.0.106 API Documentation)
Description: declaration: package: org.apache.tomcat.util.digester, class: FactoryCreateRule

# Class FactoryCreateRule

java.lang.Object
org.apache.tomcat.util.digester.Rule
org.apache.tomcat.util.digester.FactoryCreateRule

public class FactoryCreateRule extends Rule

Rule implementation that uses an `ObjectCreationFactory` to create a new object which it pushes onto the object stack. When the element is complete, the object will be popped.

This rule is intended in situations where the element's attributes are needed before the object can be created. A common scenario is for the ObjectCreationFactory implementation to use the attributes as parameters in a call to either a factory method or to a non-empty constructor.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected ObjectCreationFactory`
  `creationFactory`
  The object creation factory we will use to instantiate objects as required based on the attributes specified in the matched XML element.

  ### Fields inherited from class org.apache.tomcat.util.digester.Rule

  `digester, namespaceURI, sm`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FactoryCreateRule(ObjectCreationFactory creationFactory, boolean ignoreCreateExceptions)`
  Construct a factory create rule using the given, already instantiated, `ObjectCreationFactory`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `begin(String namespace, String name, Attributes attributes)`
  Process the beginning of this element.
  `void`
  `end(String namespace, String name)`
  Process the end of this element.
  `void`
  `finish()`
  Clean up after parsing is complete.
  `String`
  `toString()`
  Render a printable version of this Rule.

  ### Methods inherited from class org.apache.tomcat.util.digester.Rule

  `body, getDigester, getNamespaceURI, setDigester, setNamespaceURI`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### creationFactory

    protected ObjectCreationFactory creationFactory
    The object creation factory we will use to instantiate objects as required based on the attributes specified in the matched XML element.

- ## Constructor Details

  - ### FactoryCreateRule

    public FactoryCreateRule(ObjectCreationFactory creationFactory, boolean ignoreCreateExceptions)
    Construct a factory create rule using the given, already instantiated, `ObjectCreationFactory`.
    Parameters:
      `creationFactory` - called on to create the object.
      `ignoreCreateExceptions` - if true, exceptions thrown by the object creation factory will be ignored.

- ## Method Details

  - ### begin

    public void begin(String namespace, String name, Attributes attributes) throws Exception
    Process the beginning of this element.
    Overrides:
      `begin` in class `Rule`
    Parameters:
      `namespace` - the namespace URI of the matching element, or an empty string if the parser is not namespace aware or the element has no namespace
      `name` - the local name if the parser is namespace aware, or just the element name otherwise
      `attributes` - The attribute list of this element
    Throws:
      `Exception` - if an error occurs while processing the event

  - ### end

    public void end(String namespace, String name) throws Exception
    Process the end of this element.
    Overrides:
      `end` in class `Rule`
    Parameters:
      `namespace` - the namespace URI of the matching element, or an empty string if the parser is not namespace aware or the element has no namespace
      `name` - the local name if the parser is namespace aware, or just the element name otherwise
    Throws:
      `Exception` - if an error occurs while processing the event

  - ### finish

    public void finish() throws Exception
    Clean up after parsing is complete.
    Overrides:
      `finish` in class `Rule`
    Throws:
      `Exception` - if an error occurs while processing the event

  - ### toString

    public String toString()
    Render a printable version of this Rule.
    Overrides:
      `toString` in class `Object`